/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AArch64PostLegalizerCombinerImpl Combiner Match Table                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AArch64PostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 0;	 // "copy_prop"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_const", 8) != 0)
        break;
      return 10;	 // "mul_const"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "r_to_bsp", 8) != 0)
        break;
      return 58;	 // "or_to_bsp"
    }
    break;
  case 10:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 31;	 // "i2p_to_p2i"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 30;	 // "p2i_to_i2p"
    }
    break;
  case 11:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "add_sub_reg", 11) != 0)
      break;
    return 36;	 // "add_sub_reg"
  case 12:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "redundant_or", 12) != 0)
      break;
    return 9;	 // "redundant_or"
  case 13:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 2;	 // "load_and_mask"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_unmerge", 12) != 0)
        break;
      return 18;	 // "merge_unmerge"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 6;	 // "redundant_and"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_undef", 12) != 0)
        break;
      return 55;	 // "unmerge_undef"
    }
    break;
  case 14:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_same_val", 13) != 0)
        break;
      return 27;	 // "binop_same_val"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_fneg_fold", 13) != 0)
        break;
      return 33;	 // "fneg_fneg_fold"
    }
    break;
  case 15:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 1;	 // "extending_loads"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 43;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 25;	 // "select_same_val"
    }
    break;
  case 16:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 57;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 19;	 // "select_undef_cmp"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 45;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_trunc_fold", 16) != 0)
        break;
      return 32;	 // "anyext_trunc_fold"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 54;	 // "erase_undef_store"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_to_logical", 16) != 0)
        break;
      return 21;	 // "select_to_logical"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_int_zero", 16) != 0)
        break;
      return 46;	 // "undef_to_int_zero"
    }
    break;
  case 18:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 28;	 // "binop_left_to_zero"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_merge_to_zext", 16) != 0)
          break;
        return 22;	 // "fold_merge_to_zext"
      case 'p':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "trunc_fpext_fold", 16) != 0)
          break;
        return 41;	 // "fptrunc_fpext_fold"
      }
      break;
    }
    break;
  case 19:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 29;	 // "binop_right_to_zero"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "onstant_fold_binop", 18) != 0)
        break;
      return 23;	 // "constant_fold_binop"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 42;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 26;	 // "right_identity_zero"
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tate_out_of_range", 17) != 0)
          break;
        return 16;	 // "rotate_out_of_range"
      }
      break;
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_constant_cmp", 16) != 0)
          break;
        return 20;	 // "select_constant_cmp"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_trunc_sextload", 16) != 0)
          break;
        return 3;	 // "sext_trunc_sextload"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 50;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 40;	 // "bitcast_bitcast_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_sext_inreg", 19) != 0)
        break;
      return 11;	 // "redundant_sext_inreg"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "plit_store_zero_128", 19) != 0)
        break;
      return 44;	 // "split_store_zero_128"
    }
    break;
  case 21:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "utate_anyext_to_zext", 20) != 0)
        break;
      return 4;	 // "mutate_anyext_to_zext"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 35;	 // "right_identity_one_fp"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_negative_one", 20) != 0)
        break;
      return 47;	 // "undef_to_negative_one"
    }
    break;
  case 22:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "onstant_fold_fp_binop", 21) != 0)
        break;
      return 24;	 // "constant_fold_fp_binop"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 51;	 // "propagate_undef_any_op"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_int", 21) != 0)
        break;
      return 34;	 // "right_identity_one_int"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 38;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "propagate_undef_all_ops", 23) != 0)
      break;
    return 52;	 // "propagate_undef_all_ops"
  case 24:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 48;	 // "binop_left_undef_to_zero"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 7;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 3 strings to match.
    if (RuleIdentifier[0] != 'b')
      break;
    switch (RuleIdentifier[1]) {
    default: break;
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
        break;
      switch (RuleIdentifier[22]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
          break;
        return 13;	 // "bitfield_extract_from_and"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
          break;
        return 14;	 // "bitfield_extract_from_shr"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
        break;
      return 37;	 // "buildvector_identity_fold"
    }
    break;
  case 26:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 49;	 // "binop_right_undef_to_undef"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtractvecelt_pairwise_add", 25) != 0)
        break;
      return 8;	 // "extractvecelt_pairwise_add"
    }
    break;
  case 27:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "trunc_lshr_buildvector_fold", 27) != 0)
      break;
    return 39;	 // "trunc_lshr_buildvector_fold"
  case 28:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "propagate_undef_shuffle_mask", 28) != 0)
      break;
    return 53;	 // "propagate_undef_shuffle_mask"
  case 29:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 15;	 // "bitfield_extract_from_shr_and"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 17;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 32:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "bitfield_extract_from_sext_inreg", 32) != 0)
      break;
    return 12;	 // "bitfield_extract_from_sext_inreg"
  case 36:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_extract_vec_elt_out_of_bounds", 36) != 0)
      break;
    return 56;	 // "insert_extract_vec_elt_out_of_bounds"
  case 37:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "hoist_logic_op_with_same_opcode_hands", 37) != 0)
      break;
    return 5;	 // "hoist_logic_op_with_same_opcode_hands"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 59}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AArch64PostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AArch64PostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AArch64PostLegalizerCombinerOption;
static cl::list<std::string> AArch64PostLegalizerCombinerDisableOption(
    "aarch64postlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AArch64PostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AArch64PostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AArch64PostLegalizerCombinerOnlyEnableOption(
    "aarch64postlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AArch64PostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AArch64PostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AArch64PostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AArch64PostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AArch64PostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AArch64PostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64PostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64PostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64PostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64PostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const int64_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  void runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
  struct MatchInfosTy {
    std::tuple<unsigned, LLT, Register> MDInfo5;
    unsigned MDInfo8;
    ConstantFP* MDInfo10;
    InstructionStepsMatchInfo MDInfo2;
    std::function<void(MachineIRBuilder&, Register)> MDInfo6;
    PreferredTuple MDInfo0;
    std::tuple<Register, Register, Register> MDInfo12;
    Register MDInfo3;
    std::function<void(MachineIRBuilder &)> MDInfo1;
    int64_t MDInfo7;
    APInt MDInfo9;
    std::pair<Register, Register> MDInfo4;
    PtrAddChain MDInfo11;
  };
  mutable MatchInfosTy MatchInfos;

#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset AArch64PostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features;
  return Features;
}

void AArch64PostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64PostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features;
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AArch64PostLegalizerCombinerImpl::ComplexMatcherMemFn
AArch64PostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
  GICXXPred_MI_Predicate_GICombiner10,
  GICXXPred_MI_Predicate_GICombiner11,
  GICXXPred_MI_Predicate_GICombiner12,
  GICXXPred_MI_Predicate_GICombiner13,
  GICXXPred_MI_Predicate_GICombiner14,
  GICXXPred_MI_Predicate_GICombiner15,
  GICXXPred_MI_Predicate_GICombiner16,
  GICXXPred_MI_Predicate_GICombiner17,
  GICXXPred_MI_Predicate_GICombiner18,
  GICXXPred_MI_Predicate_GICombiner19,
  GICXXPred_MI_Predicate_GICombiner20,
  GICXXPred_MI_Predicate_GICombiner21,
  GICXXPred_MI_Predicate_GICombiner22,
  GICXXPred_MI_Predicate_GICombiner23,
  GICXXPred_MI_Predicate_GICombiner24,
  GICXXPred_MI_Predicate_GICombiner25,
  GICXXPred_MI_Predicate_GICombiner26,
  GICXXPred_MI_Predicate_GICombiner27,
  GICXXPred_MI_Predicate_GICombiner28,
  GICXXPred_MI_Predicate_GICombiner29,
  GICXXPred_MI_Predicate_GICombiner30,
  GICXXPred_MI_Predicate_GICombiner31,
  GICXXPred_MI_Predicate_GICombiner32,
  GICXXPred_MI_Predicate_GICombiner33,
  GICXXPred_MI_Predicate_GICombiner34,
  GICXXPred_MI_Predicate_GICombiner35,
  GICXXPred_MI_Predicate_GICombiner36,
  GICXXPred_MI_Predicate_GICombiner37,
  GICXXPred_MI_Predicate_GICombiner38,
  GICXXPred_MI_Predicate_GICombiner39,
  GICXXPred_MI_Predicate_GICombiner40,
  GICXXPred_MI_Predicate_GICombiner41,
  GICXXPred_MI_Predicate_GICombiner42,
  GICXXPred_MI_Predicate_GICombiner43,
  GICXXPred_MI_Predicate_GICombiner44,
  GICXXPred_MI_Predicate_GICombiner45,
  GICXXPred_MI_Predicate_GICombiner46,
};
bool AArch64PostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return Helper.matchCombineCopy(*State.MIs[0]);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return Helper.matchCombineExtendingLoads(*State.MIs[0], MatchInfos.MDInfo0);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchCombineLoadWithAndMask(*State.MIs[0], MatchInfos.MDInfo1);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchSextTruncSextLoad(*State.MIs[0]);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return matchMutateAnyExtToZExt(*State.MIs[0], MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], MatchInfos.MDInfo2);
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return Helper.matchRedundantAnd(*State.MIs[0], MatchInfos.MDInfo3);
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return Helper.matchXorOfAndWithSameReg(*State.MIs[0], MatchInfos.MDInfo4);
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return matchExtractVecEltPairwiseAdd(*State.MIs[0], MRI, MatchInfos.MDInfo5);
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.matchRedundantOr(*State.MIs[0], MatchInfos.MDInfo3);
  }
  case GICXXPred_MI_Predicate_GICombiner10: {
    return matchAArch64MulConstCombine(*State.MIs[0], MRI, MatchInfos.MDInfo6);
  }
  case GICXXPred_MI_Predicate_GICombiner11: {
    return Helper.matchRedundantSExtInReg(*State.MIs[0]);
  }
  case GICXXPred_MI_Predicate_GICombiner12: {
    return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], MatchInfos.MDInfo1);
  }
  case GICXXPred_MI_Predicate_GICombiner13: {
    return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], MatchInfos.MDInfo1);
  }
  case GICXXPred_MI_Predicate_GICombiner14: {
    return Helper.matchBitfieldExtractFromShr(*State.MIs[0], MatchInfos.MDInfo1);
  }
  case GICXXPred_MI_Predicate_GICombiner15: {
    return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], MatchInfos.MDInfo1);
  }
  case GICXXPred_MI_Predicate_GICombiner16: {
    return Helper.matchRotateOutOfRange(*State.MIs[0]);
  }
  case GICXXPred_MI_Predicate_GICombiner17: {
    return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], MatchInfos.MDInfo7);
  }
  case GICXXPred_MI_Predicate_GICombiner18: {
    return Helper.matchCombineMergeUnmerge(*State.MIs[0], MatchInfos.MDInfo3);
  }
  case GICXXPred_MI_Predicate_GICombiner19: {
    return Helper.matchConstantSelectCmp(*State.MIs[0], MatchInfos.MDInfo8);
  }
  case GICXXPred_MI_Predicate_GICombiner20: {
    return Helper.matchSelectToLogical(*State.MIs[0], MatchInfos.MDInfo1);
  }
  case GICXXPred_MI_Predicate_GICombiner21: {
    return matchFoldMergeToZext(*State.MIs[0], MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner22: {
    return Helper.matchConstantFoldBinOp(*State.MIs[0], MatchInfos.MDInfo9);
  }
  case GICXXPred_MI_Predicate_GICombiner23: {
    return Helper.matchConstantFoldFPBinOp(*State.MIs[0], MatchInfos.MDInfo10);
  }
  case GICXXPred_MI_Predicate_GICombiner24: {
    return Helper.matchSelectSameVal(*State.MIs[0]);
  }
  case GICXXPred_MI_Predicate_GICombiner25: {
    return Helper.matchOperandIsZero(*State.MIs[0], 1);
  }
  case GICXXPred_MI_Predicate_GICombiner26: {
    return Helper.matchCombineI2PToP2I(*State.MIs[0], MatchInfos.MDInfo3);
  }
  case GICXXPred_MI_Predicate_GICombiner27: {
    MatchInfos.MDInfo3 = State.MIs[1]->getOperand(1).getReg(); return true;
    llvm_unreachable("GICombiner27 should have returned");
  }
  case GICXXPred_MI_Predicate_GICombiner28: {
    return Helper.matchCombineAnyExtTrunc(*State.MIs[0], MatchInfos.MDInfo3);
  }
  case GICXXPred_MI_Predicate_GICombiner29: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner30: {
    return Helper.matchBuildVectorIdentityFold(*State.MIs[0], MatchInfos.MDInfo3);
  }
  case GICXXPred_MI_Predicate_GICombiner31: {
    return Helper.matchTruncBuildVectorFold(*State.MIs[0], MatchInfos.MDInfo3);
  }
  case GICXXPred_MI_Predicate_GICombiner32: {
    return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], MatchInfos.MDInfo3);
  }
  case GICXXPred_MI_Predicate_GICombiner33: {
    return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());
  }
  case GICXXPred_MI_Predicate_GICombiner34: {
    return Helper.matchPtrAddImmedChain(*State.MIs[0], MatchInfos.MDInfo11);
  }
  case GICXXPred_MI_Predicate_GICombiner35: {
    return Helper.matchOverlappingAnd(*State.MIs[0], MatchInfos.MDInfo1);
  }
  case GICXXPred_MI_Predicate_GICombiner36: {
    return matchSplitStoreZero128(*State.MIs[0], MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner37: {
    return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);
  }
  case GICXXPred_MI_Predicate_GICombiner38: {
    return Helper.matchOperandIsUndef(*State.MIs[0], 1);
  }
  case GICXXPred_MI_Predicate_GICombiner39: {
    return Helper.matchOperandIsUndef(*State.MIs[0], 2);
  }
  case GICXXPred_MI_Predicate_GICombiner40: {
    return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);
  }
  case GICXXPred_MI_Predicate_GICombiner41: {
    return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);
  }
  case GICXXPred_MI_Predicate_GICombiner42: {
    return Helper.matchUndefStore(*State.MIs[0]);
  }
  case GICXXPred_MI_Predicate_GICombiner43: {
    return Helper.matchCombineUnmergeUndef(*State.MIs[0], MatchInfos.MDInfo1);
  }
  case GICXXPred_MI_Predicate_GICombiner44: {
    return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);
  }
  case GICXXPred_MI_Predicate_GICombiner45: {
    return Helper.matchSimplifySelectToMinMax(*State.MIs[0], MatchInfos.MDInfo1);
  }
  case GICXXPred_MI_Predicate_GICombiner46: {
    return matchOrToBSP(*State.MIs[0], MRI, MatchInfos.MDInfo12);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
};

bool AArch64PostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AArch64PostLegalizerCombinerImpl::CustomRendererFn
AArch64PostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AArch64PostLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  NewMIVector OutMIs;
  State.MIs.clear();
  State.MIs.push_back(&I);
  MatchInfos = MatchInfosTy();

  if (executeMatchTable(*this, OutMIs, State, ExecInfo, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr, &Observer)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_CombineApplyGICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_CombineApplyGICombiner1,
  GICXXCustomAction_CombineApplyGICombiner2,
  GICXXCustomAction_CombineApplyGICombiner3,
  GICXXCustomAction_CombineApplyGICombiner4,
  GICXXCustomAction_CombineApplyGICombiner5,
  GICXXCustomAction_CombineApplyGICombiner6,
  GICXXCustomAction_CombineApplyGICombiner7,
  GICXXCustomAction_CombineApplyGICombiner8,
  GICXXCustomAction_CombineApplyGICombiner9,
  GICXXCustomAction_CombineApplyGICombiner10,
  GICXXCustomAction_CombineApplyGICombiner11,
  GICXXCustomAction_CombineApplyGICombiner12,
  GICXXCustomAction_CombineApplyGICombiner13,
  GICXXCustomAction_CombineApplyGICombiner14,
  GICXXCustomAction_CombineApplyGICombiner15,
  GICXXCustomAction_CombineApplyGICombiner16,
  GICXXCustomAction_CombineApplyGICombiner17,
  GICXXCustomAction_CombineApplyGICombiner18,
  GICXXCustomAction_CombineApplyGICombiner19,
  GICXXCustomAction_CombineApplyGICombiner20,
  GICXXCustomAction_CombineApplyGICombiner21,
  GICXXCustomAction_CombineApplyGICombiner22,
  GICXXCustomAction_CombineApplyGICombiner23,
  GICXXCustomAction_CombineApplyGICombiner24,
  GICXXCustomAction_CombineApplyGICombiner25,
  GICXXCustomAction_CombineApplyGICombiner26,
  GICXXCustomAction_CombineApplyGICombiner27,
  GICXXCustomAction_CombineApplyGICombiner28,
};
void AArch64PostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  switch(ApplyID) {
  case GICXXCustomAction_CombineApplyGICombiner0:{
    Helper.applyCombineCopy(*State.MIs[0]);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner1:{
    Helper.applyCombineExtendingLoads(*State.MIs[0], MatchInfos.MDInfo0);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner2:{
    Helper.applyBuildFn(*State.MIs[0], MatchInfos.MDInfo1);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner3:{
    Helper.applySextTruncSextLoad(*State.MIs[0]);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner4:{
    applyMutateAnyExtToZExt(*State.MIs[0], MRI, B, Observer);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner5:{
    Helper.applyBuildInstructionSteps(*State.MIs[0], MatchInfos.MDInfo2);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner6:{
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], MatchInfos.MDInfo3);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner7:{
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], MatchInfos.MDInfo4);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner8:{
    applyExtractVecEltPairwiseAdd(*State.MIs[0], MRI, B, MatchInfos.MDInfo5);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner9:{
    applyAArch64MulConstCombine(*State.MIs[0], MRI, B, MatchInfos.MDInfo6);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner10:{
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner11:{
    Helper.applyRotateOutOfRange(*State.MIs[0]);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner12:{
    Helper.replaceInstWithConstant(*State.MIs[0], MatchInfos.MDInfo7);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner13:{
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], MatchInfos.MDInfo8);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner14:{
    applyFoldMergeToZext(*State.MIs[0], MRI, B, Observer);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner15:{
    Helper.replaceInstWithConstant(*State.MIs[0], MatchInfos.MDInfo9);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner16:{
    Helper.replaceInstWithFConstant(*State.MIs[0], MatchInfos.MDInfo10);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner17:{
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner18:{
    Helper.applyCombineI2PToP2I(*State.MIs[0], MatchInfos.MDInfo3);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner19:{
    Helper.applyCombineP2IToI2P(*State.MIs[0], MatchInfos.MDInfo3);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner20:{
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner21:{
    Helper.applyPtrAddImmedChain(*State.MIs[0], MatchInfos.MDInfo11);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner22:{
    applySplitStoreZero128(*State.MIs[0], MRI, B, Observer);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner23:{
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner24:{
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner25:{
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner26:{
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner27:{
    Helper.eraseInst(*State.MIs[0]);
    return;
  }
  case GICXXCustomAction_CombineApplyGICombiner28:{
    applyOrToBSP(*State.MIs[0], MRI, B, MatchInfos.MDInfo12);
    return;
  }
}
  llvm_unreachable("Unknown Apply Action");
}
const int64_t *AArch64PostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static int64_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/19, 213, /*)*//*default:*//*Label 47*/ 1553,
    /*TargetOpcode::COPY*//*Label 0*/ 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_ADD*//*Label 1*/ 210,
    /*TargetOpcode::G_SUB*//*Label 2*/ 314,
    /*TargetOpcode::G_MUL*//*Label 3*/ 356,
    /*TargetOpcode::G_SDIV*//*Label 4*/ 429,
    /*TargetOpcode::G_UDIV*//*Label 5*/ 440,
    /*TargetOpcode::G_SREM*//*Label 6*/ 461,
    /*TargetOpcode::G_UREM*//*Label 7*/ 472, 0, 0,
    /*TargetOpcode::G_AND*//*Label 8*/ 493,
    /*TargetOpcode::G_OR*//*Label 9*/ 586,
    /*TargetOpcode::G_XOR*//*Label 10*/ 680, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ 742, 0,
    /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ 753,
    /*TargetOpcode::G_BUILD_VECTOR*//*Label 13*/ 774,
    /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 14*/ 785, 0,
    /*TargetOpcode::G_PTRTOINT*//*Label 15*/ 796,
    /*TargetOpcode::G_INTTOPTR*//*Label 16*/ 816,
    /*TargetOpcode::G_BITCAST*//*Label 17*/ 827, 0, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_LOAD*//*Label 18*/ 847,
    /*TargetOpcode::G_SEXTLOAD*//*Label 19*/ 858,
    /*TargetOpcode::G_ZEXTLOAD*//*Label 20*/ 869, 0, 0, 0,
    /*TargetOpcode::G_STORE*//*Label 21*/ 880, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_ANYEXT*//*Label 22*/ 901,
    /*TargetOpcode::G_TRUNC*//*Label 23*/ 922, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_SEXT_INREG*//*Label 24*/ 953, 0,
    /*TargetOpcode::G_SHL*//*Label 25*/ 984,
    /*TargetOpcode::G_LSHR*//*Label 26*/ 1036,
    /*TargetOpcode::G_ASHR*//*Label 27*/ 1098, 0, 0,
    /*TargetOpcode::G_ROTR*//*Label 28*/ 1160,
    /*TargetOpcode::G_ROTL*//*Label 29*/ 1192,
    /*TargetOpcode::G_ICMP*//*Label 30*/ 1224, 0,
    /*TargetOpcode::G_SELECT*//*Label 31*/ 1235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_FADD*//*Label 32*/ 1302,
    /*TargetOpcode::G_FSUB*//*Label 33*/ 1313,
    /*TargetOpcode::G_FMUL*//*Label 34*/ 1324, 0, 0,
    /*TargetOpcode::G_FDIV*//*Label 35*/ 1355, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_FNEG*//*Label 36*/ 1366, 0,
    /*TargetOpcode::G_FPTRUNC*//*Label 37*/ 1393,
    /*TargetOpcode::G_FPTOSI*//*Label 38*/ 1413,
    /*TargetOpcode::G_FPTOUI*//*Label 39*/ 1424,
    /*TargetOpcode::G_SITOFP*//*Label 40*/ 1435,
    /*TargetOpcode::G_UITOFP*//*Label 41*/ 1446, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_PTR_ADD*//*Label 42*/ 1457, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_ABS*//*Label 43*/ 1489, 0, 0, 0, 0,
    /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 44*/ 1500,
    /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 45*/ 1511,
    /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 46*/ 1532,
    // Label 0: @199
    GIM_Try, /*On fail goto*//*Label 48*/ 209, // Rule ID 0 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule0Enabled,
      // MIs[0] d
      // No operand predicates
      // MIs[0] s
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner0,
      // Combiner Rule #0: copy_prop
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner0,
      GIR_Done,
    // Label 48: @209
    GIM_Reject,
    // Label 1: @210
    GIM_Try, /*On fail goto*//*Label 49*/ 220, // Rule ID 30 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule23Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner22,
      // Combiner Rule #23: constant_fold_binop; wip_match_opcode 'G_ADD'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner15,
      GIR_Done,
    // Label 49: @220
    GIM_Try, /*On fail goto*//*Label 50*/ 230, // Rule ID 90 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule51Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #51: propagate_undef_any_op; wip_match_opcode 'G_ADD'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 50: @230
    GIM_Try, /*On fail goto*//*Label 51*/ 261, // Rule ID 68 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule36Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] __add_sub_reg_match_0.tmp
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_SUB,
      // MIs[1] src
      // No operand predicates
      // MIs[1] __add_sub_reg_match_0.x
      // No operand predicates
      // MIs[0] __add_sub_reg_match_0.x
      GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
      GIM_CheckIsSafeToFold, /*InsnID*/1,
      // Combiner Rule #36: add_sub_reg @ [__add_sub_reg_match_0[1]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 51: @261
    GIM_Try, /*On fail goto*//*Label 52*/ 292, // Rule ID 67 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule36Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] __add_sub_reg_match_0.x
      // No operand predicates
      // MIs[0] __add_sub_reg_match_0.tmp
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_SUB,
      // MIs[1] src
      // No operand predicates
      // MIs[1] __add_sub_reg_match_0.x
      GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
      GIM_CheckIsSafeToFold, /*InsnID*/1,
      // Combiner Rule #36: add_sub_reg @ [__add_sub_reg_match_0[0]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 52: @292
    GIM_Try, /*On fail goto*//*Label 53*/ 313, // Rule ID 45 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule26Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #26: right_identity_zero @ [__right_identity_zero_match_0[1]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 53: @313
    GIM_Reject,
    // Label 2: @314
    GIM_Try, /*On fail goto*//*Label 54*/ 324, // Rule ID 31 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule23Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner22,
      // Combiner Rule #23: constant_fold_binop; wip_match_opcode 'G_SUB'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner15,
      GIR_Done,
    // Label 54: @324
    GIM_Try, /*On fail goto*//*Label 55*/ 334, // Rule ID 93 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule51Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #51: propagate_undef_any_op; wip_match_opcode 'G_SUB'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 55: @334
    GIM_Try, /*On fail goto*//*Label 56*/ 355, // Rule ID 44 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule26Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #26: right_identity_zero @ [__right_identity_zero_match_0[0]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 56: @355
    GIM_Reject,
    // Label 3: @356
    GIM_Try, /*On fail goto*//*Label 57*/ 366, // Rule ID 14 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule10Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner10,
      // Combiner Rule #10: mul_const; wip_match_opcode 'G_MUL'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner9,
      GIR_Done,
    // Label 57: @366
    GIM_Try, /*On fail goto*//*Label 58*/ 376, // Rule ID 32 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule23Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner22,
      // Combiner Rule #23: constant_fold_binop; wip_match_opcode 'G_MUL'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner15,
      GIR_Done,
    // Label 58: @376
    GIM_Try, /*On fail goto*//*Label 59*/ 386, // Rule ID 81 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule46Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #46: undef_to_int_zero; wip_match_opcode 'G_MUL'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner24,
      GIR_Done,
    // Label 59: @386
    GIM_Try, /*On fail goto*//*Label 60*/ 407, // Rule ID 60 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule29Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] zero
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
      // Combiner Rule #29: binop_right_to_zero
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 60: @407
    GIM_Try, /*On fail goto*//*Label 61*/ 428, // Rule ID 65 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule34Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] x
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 1,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #34: right_identity_one_int
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 61: @428
    GIM_Reject,
    // Label 4: @429
    GIM_Try, /*On fail goto*//*Label 62*/ 439, // Rule ID 56 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule28Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner25,
      // Combiner Rule #28: binop_left_to_zero; wip_match_opcode 'G_SDIV'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner10,
      GIR_Done,
    // Label 62: @439
    GIM_Reject,
    // Label 5: @440
    GIM_Try, /*On fail goto*//*Label 63*/ 450, // Rule ID 57 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule28Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner25,
      // Combiner Rule #28: binop_left_to_zero; wip_match_opcode 'G_UDIV'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner10,
      GIR_Done,
    // Label 63: @450
    GIM_Try, /*On fail goto*//*Label 64*/ 460, // Rule ID 84 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule48Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner38,
      // Combiner Rule #48: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner24,
      GIR_Done,
    // Label 64: @460
    GIM_Reject,
    // Label 6: @461
    GIM_Try, /*On fail goto*//*Label 65*/ 471, // Rule ID 58 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule28Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner25,
      // Combiner Rule #28: binop_left_to_zero; wip_match_opcode 'G_SREM'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner10,
      GIR_Done,
    // Label 65: @471
    GIM_Reject,
    // Label 7: @472
    GIM_Try, /*On fail goto*//*Label 66*/ 482, // Rule ID 59 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule28Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner25,
      // Combiner Rule #28: binop_left_to_zero; wip_match_opcode 'G_UREM'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner10,
      GIR_Done,
    // Label 66: @482
    GIM_Try, /*On fail goto*//*Label 67*/ 492, // Rule ID 85 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule48Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner38,
      // Combiner Rule #48: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner24,
      GIR_Done,
    // Label 67: @492
    GIM_Reject,
    // Label 8: @493
    GIM_Try, /*On fail goto*//*Label 68*/ 503, // Rule ID 4 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule2Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner2,
      // Combiner Rule #2: load_and_mask; wip_match_opcode 'G_AND'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 68: @503
    GIM_Try, /*On fail goto*//*Label 69*/ 513, // Rule ID 7 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule5Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner5,
      // Combiner Rule #5: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner5,
      GIR_Done,
    // Label 69: @513
    GIM_Try, /*On fail goto*//*Label 70*/ 523, // Rule ID 10 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule6Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner6,
      // Combiner Rule #6: redundant_and; wip_match_opcode 'G_AND'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner6,
      GIR_Done,
    // Label 70: @523
    GIM_Try, /*On fail goto*//*Label 71*/ 533, // Rule ID 17 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule13Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner13,
      // Combiner Rule #13: bitfield_extract_from_and; wip_match_opcode 'G_AND'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 71: @533
    GIM_Try, /*On fail goto*//*Label 72*/ 543, // Rule ID 33 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule23Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner22,
      // Combiner Rule #23: constant_fold_binop; wip_match_opcode 'G_AND'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner15,
      GIR_Done,
    // Label 72: @543
    GIM_Try, /*On fail goto*//*Label 73*/ 553, // Rule ID 76 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule43Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner35,
      // Combiner Rule #43: overlapping_and; wip_match_opcode 'G_AND'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 73: @553
    GIM_Try, /*On fail goto*//*Label 74*/ 563, // Rule ID 80 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule46Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #46: undef_to_int_zero; wip_match_opcode 'G_AND'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner24,
      GIR_Done,
    // Label 74: @563
    GIM_Try, /*On fail goto*//*Label 75*/ 585, // Rule ID 54 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule27Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] src
      // No operand predicates
      // MIs[0] src
      GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #27: binop_same_val @ [__binop_same_val_match_0[0]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 75: @585
    GIM_Reject,
    // Label 9: @586
    GIM_Try, /*On fail goto*//*Label 76*/ 596, // Rule ID 8 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule5Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner5,
      // Combiner Rule #5: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner5,
      GIR_Done,
    // Label 76: @596
    GIM_Try, /*On fail goto*//*Label 77*/ 606, // Rule ID 13 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule9Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner9,
      // Combiner Rule #9: redundant_or; wip_match_opcode 'G_OR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner6,
      GIR_Done,
    // Label 77: @606
    GIM_Try, /*On fail goto*//*Label 78*/ 616, // Rule ID 34 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule23Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner22,
      // Combiner Rule #23: constant_fold_binop; wip_match_opcode 'G_OR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner15,
      GIR_Done,
    // Label 78: @616
    GIM_Try, /*On fail goto*//*Label 79*/ 626, // Rule ID 82 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule47Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #47: undef_to_negative_one; wip_match_opcode 'G_OR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner25,
      GIR_Done,
    // Label 79: @626
    GIM_Try, /*On fail goto*//*Label 80*/ 636, // Rule ID 103 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule58Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner46,
      // Combiner Rule #58: or_to_bsp; wip_match_opcode 'G_OR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner28,
      GIR_Done,
    // Label 80: @636
    GIM_Try, /*On fail goto*//*Label 81*/ 658, // Rule ID 55 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule27Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] src
      // No operand predicates
      // MIs[0] src
      GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #27: binop_same_val @ [__binop_same_val_match_0[1]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 81: @658
    GIM_Try, /*On fail goto*//*Label 82*/ 679, // Rule ID 46 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule26Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #26: right_identity_zero @ [__right_identity_zero_match_0[2]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 82: @679
    GIM_Reject,
    // Label 10: @680
    GIM_Try, /*On fail goto*//*Label 83*/ 690, // Rule ID 9 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule5Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner5,
      // Combiner Rule #5: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner5,
      GIR_Done,
    // Label 83: @690
    GIM_Try, /*On fail goto*//*Label 84*/ 700, // Rule ID 11 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule7Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner7,
      // Combiner Rule #7: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner7,
      GIR_Done,
    // Label 84: @700
    GIM_Try, /*On fail goto*//*Label 85*/ 710, // Rule ID 35 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule23Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner22,
      // Combiner Rule #23: constant_fold_binop; wip_match_opcode 'G_XOR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner15,
      GIR_Done,
    // Label 85: @710
    GIM_Try, /*On fail goto*//*Label 86*/ 720, // Rule ID 94 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule51Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #51: propagate_undef_any_op; wip_match_opcode 'G_XOR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 86: @720
    GIM_Try, /*On fail goto*//*Label 87*/ 741, // Rule ID 47 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule26Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #26: right_identity_zero @ [__right_identity_zero_match_0[3]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 87: @741
    GIM_Reject,
    // Label 11: @742
    GIM_Try, /*On fail goto*//*Label 88*/ 752, // Rule ID 99 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule55Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner43,
      // Combiner Rule #55: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 88: @752
    GIM_Reject,
    // Label 12: @753
    GIM_Try, /*On fail goto*//*Label 89*/ 763, // Rule ID 25 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule18Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner18,
      // Combiner Rule #18: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner6,
      GIR_Done,
    // Label 89: @763
    GIM_Try, /*On fail goto*//*Label 90*/ 773, // Rule ID 29 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule22Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner21,
      // Combiner Rule #22: fold_merge_to_zext; wip_match_opcode 'G_MERGE_VALUES'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner14,
      GIR_Done,
    // Label 90: @773
    GIM_Reject,
    // Label 13: @774
    GIM_Try, /*On fail goto*//*Label 91*/ 784, // Rule ID 70 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule37Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner30,
      // Combiner Rule #37: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner6,
      GIR_Done,
    // Label 91: @784
    GIM_Reject,
    // Label 14: @785
    GIM_Try, /*On fail goto*//*Label 92*/ 795, // Rule ID 69 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule37Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner30,
      // Combiner Rule #37: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner6,
      GIR_Done,
    // Label 92: @795
    GIM_Reject,
    // Label 15: @796
    GIM_Try, /*On fail goto*//*Label 93*/ 815, // Rule ID 62 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule31Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] t
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_INTTOPTR,
      // MIs[1] ptr
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner27,
      GIM_CheckIsSafeToFold, /*InsnID*/1,
      // Combiner Rule #31: i2p_to_p2i
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner19,
      GIR_Done,
    // Label 93: @815
    GIM_Reject,
    // Label 16: @816
    GIM_Try, /*On fail goto*//*Label 94*/ 826, // Rule ID 61 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule30Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner26,
      // Combiner Rule #30: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner18,
      GIR_Done,
    // Label 94: @826
    GIM_Reject,
    // Label 17: @827
    GIM_Try, /*On fail goto*//*Label 95*/ 846, // Rule ID 73 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule40Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] src1
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_BITCAST,
      // MIs[1] src0
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner33,
      GIM_CheckIsSafeToFold, /*InsnID*/1,
      // Combiner Rule #40: bitcast_bitcast_fold
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner20,
      GIR_Done,
    // Label 95: @846
    GIM_Reject,
    // Label 18: @847
    GIM_Try, /*On fail goto*//*Label 96*/ 857, // Rule ID 1 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule1Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner1,
      // Combiner Rule #1: extending_loads; wip_match_opcode 'G_LOAD'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner1,
      GIR_Done,
    // Label 96: @857
    GIM_Reject,
    // Label 19: @858
    GIM_Try, /*On fail goto*//*Label 97*/ 868, // Rule ID 2 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule1Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner1,
      // Combiner Rule #1: extending_loads; wip_match_opcode 'G_SEXTLOAD'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner1,
      GIR_Done,
    // Label 97: @868
    GIM_Reject,
    // Label 20: @869
    GIM_Try, /*On fail goto*//*Label 98*/ 879, // Rule ID 3 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule1Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner1,
      // Combiner Rule #1: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner1,
      GIR_Done,
    // Label 98: @879
    GIM_Reject,
    // Label 21: @880
    GIM_Try, /*On fail goto*//*Label 99*/ 890, // Rule ID 77 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule44Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner36,
      // Combiner Rule #44: split_store_zero_128; wip_match_opcode 'G_STORE'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner22,
      GIR_Done,
    // Label 99: @890
    GIM_Try, /*On fail goto*//*Label 100*/ 900, // Rule ID 98 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule54Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner42,
      // Combiner Rule #54: erase_undef_store; wip_match_opcode 'G_STORE'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner27,
      GIR_Done,
    // Label 100: @900
    GIM_Reject,
    // Label 22: @901
    GIM_Try, /*On fail goto*//*Label 101*/ 911, // Rule ID 6 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule4Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner4,
      // Combiner Rule #4: mutate_anyext_to_zext; wip_match_opcode 'G_ANYEXT'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner4,
      GIR_Done,
    // Label 101: @911
    GIM_Try, /*On fail goto*//*Label 102*/ 921, // Rule ID 63 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule32Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner28,
      // Combiner Rule #32: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner6,
      GIR_Done,
    // Label 102: @921
    GIM_Reject,
    // Label 23: @922
    GIM_Try, /*On fail goto*//*Label 103*/ 932, // Rule ID 71 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule38Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner31,
      // Combiner Rule #38: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner6,
      GIR_Done,
    // Label 103: @932
    GIM_Try, /*On fail goto*//*Label 104*/ 942, // Rule ID 72 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule39Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner32,
      // Combiner Rule #39: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner6,
      GIR_Done,
    // Label 104: @942
    GIM_Try, /*On fail goto*//*Label 105*/ 952, // Rule ID 95 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule51Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #51: propagate_undef_any_op; wip_match_opcode 'G_TRUNC'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 105: @952
    GIM_Reject,
    // Label 24: @953
    GIM_Try, /*On fail goto*//*Label 106*/ 963, // Rule ID 5 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule3Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner3,
      // Combiner Rule #3: sext_trunc_sextload; wip_match_opcode 'G_SEXT_INREG'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner3,
      GIR_Done,
    // Label 106: @963
    GIM_Try, /*On fail goto*//*Label 107*/ 973, // Rule ID 15 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule11Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner11,
      // Combiner Rule #11: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner10,
      GIR_Done,
    // Label 107: @973
    GIM_Try, /*On fail goto*//*Label 108*/ 983, // Rule ID 16 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule12Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner12,
      // Combiner Rule #12: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 108: @983
    GIM_Reject,
    // Label 25: @984
    GIM_Try, /*On fail goto*//*Label 109*/ 994, // Rule ID 36 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule23Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner22,
      // Combiner Rule #23: constant_fold_binop; wip_match_opcode 'G_SHL'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner15,
      GIR_Done,
    // Label 109: @994
    GIM_Try, /*On fail goto*//*Label 110*/ 1004, // Rule ID 83 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule48Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner38,
      // Combiner Rule #48: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner24,
      GIR_Done,
    // Label 110: @1004
    GIM_Try, /*On fail goto*//*Label 111*/ 1014, // Rule ID 86 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule49Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner39,
      // Combiner Rule #49: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 111: @1014
    GIM_Try, /*On fail goto*//*Label 112*/ 1035, // Rule ID 48 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule26Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #26: right_identity_zero @ [__right_identity_zero_match_0[4]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 112: @1035
    GIM_Reject,
    // Label 26: @1036
    GIM_Try, /*On fail goto*//*Label 113*/ 1046, // Rule ID 19 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule14Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner14,
      // Combiner Rule #14: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 113: @1046
    GIM_Try, /*On fail goto*//*Label 114*/ 1056, // Rule ID 21 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule15Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner15,
      // Combiner Rule #15: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 114: @1056
    GIM_Try, /*On fail goto*//*Label 115*/ 1066, // Rule ID 37 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule23Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner22,
      // Combiner Rule #23: constant_fold_binop; wip_match_opcode 'G_LSHR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner15,
      GIR_Done,
    // Label 115: @1066
    GIM_Try, /*On fail goto*//*Label 116*/ 1076, // Rule ID 88 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule49Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner39,
      // Combiner Rule #49: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 116: @1076
    GIM_Try, /*On fail goto*//*Label 117*/ 1097, // Rule ID 50 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule26Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #26: right_identity_zero @ [__right_identity_zero_match_0[6]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 117: @1097
    GIM_Reject,
    // Label 27: @1098
    GIM_Try, /*On fail goto*//*Label 118*/ 1108, // Rule ID 18 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule14Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner14,
      // Combiner Rule #14: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 118: @1108
    GIM_Try, /*On fail goto*//*Label 119*/ 1118, // Rule ID 20 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule15Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner15,
      // Combiner Rule #15: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 119: @1118
    GIM_Try, /*On fail goto*//*Label 120*/ 1128, // Rule ID 38 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule23Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner22,
      // Combiner Rule #23: constant_fold_binop; wip_match_opcode 'G_ASHR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner15,
      GIR_Done,
    // Label 120: @1128
    GIM_Try, /*On fail goto*//*Label 121*/ 1138, // Rule ID 87 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule49Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner39,
      // Combiner Rule #49: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 121: @1138
    GIM_Try, /*On fail goto*//*Label 122*/ 1159, // Rule ID 49 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule26Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #26: right_identity_zero @ [__right_identity_zero_match_0[5]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 122: @1159
    GIM_Reject,
    // Label 28: @1160
    GIM_Try, /*On fail goto*//*Label 123*/ 1170, // Rule ID 22 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule16Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner16,
      // Combiner Rule #16: rotate_out_of_range; wip_match_opcode 'G_ROTR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner11,
      GIR_Done,
    // Label 123: @1170
    GIM_Try, /*On fail goto*//*Label 124*/ 1191, // Rule ID 53 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule26Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #26: right_identity_zero @ [__right_identity_zero_match_0[9]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 124: @1191
    GIM_Reject,
    // Label 29: @1192
    GIM_Try, /*On fail goto*//*Label 125*/ 1202, // Rule ID 23 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule16Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner16,
      // Combiner Rule #16: rotate_out_of_range; wip_match_opcode 'G_ROTL'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner11,
      GIR_Done,
    // Label 125: @1202
    GIM_Try, /*On fail goto*//*Label 126*/ 1223, // Rule ID 52 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule26Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #26: right_identity_zero @ [__right_identity_zero_match_0[8]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 126: @1223
    GIM_Reject,
    // Label 30: @1224
    GIM_Try, /*On fail goto*//*Label 127*/ 1234, // Rule ID 24 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule17Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner17,
      // Combiner Rule #17: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner12,
      GIR_Done,
    // Label 127: @1234
    GIM_Reject,
    // Label 31: @1235
    GIM_Try, /*On fail goto*//*Label 128*/ 1245, // Rule ID 27 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule20Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner19,
      // Combiner Rule #20: select_constant_cmp; wip_match_opcode 'G_SELECT'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner13,
      GIR_Done,
    // Label 128: @1245
    GIM_Try, /*On fail goto*//*Label 129*/ 1255, // Rule ID 28 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule21Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner20,
      // Combiner Rule #21: select_to_logical; wip_match_opcode 'G_SELECT'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 129: @1255
    GIM_Try, /*On fail goto*//*Label 130*/ 1265, // Rule ID 43 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule25Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner24,
      // Combiner Rule #25: select_same_val; wip_match_opcode 'G_SELECT'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner17,
      GIR_Done,
    // Label 130: @1265
    GIM_Try, /*On fail goto*//*Label 131*/ 1275, // Rule ID 102 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule57Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner45,
      // Combiner Rule #57: select_to_minmax; wip_match_opcode 'G_SELECT'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner2,
      GIR_Done,
    // Label 131: @1275
    GIM_Try, /*On fail goto*//*Label 132*/ 1301, // Rule ID 26 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule19Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] undef
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_IMPLICIT_DEF,
      // MIs[0] x
      // No operand predicates
      // MIs[0] y
      // No operand predicates
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
      GIM_CheckIsSafeToFold, /*InsnID*/1,
      // Combiner Rule #19: select_undef_cmp
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 132: @1301
    GIM_Reject,
    // Label 32: @1302
    GIM_Try, /*On fail goto*//*Label 133*/ 1312, // Rule ID 39 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule24Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner23,
      // Combiner Rule #24: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner16,
      GIR_Done,
    // Label 133: @1312
    GIM_Reject,
    // Label 33: @1313
    GIM_Try, /*On fail goto*//*Label 134*/ 1323, // Rule ID 40 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule24Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner23,
      // Combiner Rule #24: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner16,
      GIR_Done,
    // Label 134: @1323
    GIM_Reject,
    // Label 34: @1324
    GIM_Try, /*On fail goto*//*Label 135*/ 1334, // Rule ID 41 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule24Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner23,
      // Combiner Rule #24: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner16,
      GIR_Done,
    // Label 135: @1334
    GIM_Try, /*On fail goto*//*Label 136*/ 1354, // Rule ID 66 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule35Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] x
      // No operand predicates
      // MIs[0] y
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner29,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #35: right_identity_one_fp
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 136: @1354
    GIM_Reject,
    // Label 35: @1355
    GIM_Try, /*On fail goto*//*Label 137*/ 1365, // Rule ID 42 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule24Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner23,
      // Combiner Rule #24: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner16,
      GIR_Done,
    // Label 137: @1365
    GIM_Reject,
    // Label 36: @1366
    GIM_Try, /*On fail goto*//*Label 138*/ 1392, // Rule ID 64 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule33Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] t
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_FNEG,
      // MIs[1] src
      // No operand predicates
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
      GIM_CheckIsSafeToFold, /*InsnID*/1,
      // Combiner Rule #33: fneg_fneg_fold
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 138: @1392
    GIM_Reject,
    // Label 37: @1393
    GIM_Try, /*On fail goto*//*Label 139*/ 1412, // Rule ID 74 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule41Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] src1
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_FPEXT,
      // MIs[1] src0
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner33,
      GIM_CheckIsSafeToFold, /*InsnID*/1,
      // Combiner Rule #41: fptrunc_fpext_fold
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner20,
      GIR_Done,
    // Label 139: @1412
    GIM_Reject,
    // Label 38: @1413
    GIM_Try, /*On fail goto*//*Label 140*/ 1423, // Rule ID 91 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule51Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #51: propagate_undef_any_op; wip_match_opcode 'G_FPTOSI'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 140: @1423
    GIM_Reject,
    // Label 39: @1424
    GIM_Try, /*On fail goto*//*Label 141*/ 1434, // Rule ID 92 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule51Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #51: propagate_undef_any_op; wip_match_opcode 'G_FPTOUI'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 141: @1434
    GIM_Reject,
    // Label 40: @1435
    GIM_Try, /*On fail goto*//*Label 142*/ 1445, // Rule ID 79 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule45Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #45: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner23,
      GIR_Done,
    // Label 142: @1445
    GIM_Reject,
    // Label 41: @1446
    GIM_Try, /*On fail goto*//*Label 143*/ 1456, // Rule ID 78 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule45Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner37,
      // Combiner Rule #45: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner23,
      GIR_Done,
    // Label 143: @1456
    GIM_Reject,
    // Label 42: @1457
    GIM_Try, /*On fail goto*//*Label 144*/ 1467, // Rule ID 75 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule42Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner34,
      // Combiner Rule #42: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner21,
      GIR_Done,
    // Label 144: @1467
    GIM_Try, /*On fail goto*//*Label 145*/ 1488, // Rule ID 51 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule26Enabled,
      // MIs[0] dst
      // No operand predicates
      // MIs[0] lhs
      // No operand predicates
      // MIs[0] Operand 2
      GIM_CheckConstantInt, /*MI*/0, /*Op*/2, 0,
      GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      // Combiner Rule #26: right_identity_zero @ [__right_identity_zero_match_0[7]]
      GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_Done,
    // Label 145: @1488
    GIM_Reject,
    // Label 43: @1489
    GIM_Try, /*On fail goto*//*Label 146*/ 1499, // Rule ID 89 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule50Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner38,
      // Combiner Rule #50: unary_undef_to_zero; wip_match_opcode 'G_ABS'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner24,
      GIR_Done,
    // Label 146: @1499
    GIM_Reject,
    // Label 44: @1500
    GIM_Try, /*On fail goto*//*Label 147*/ 1510, // Rule ID 100 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule56Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner44,
      // Combiner Rule #56: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 147: @1510
    GIM_Reject,
    // Label 45: @1511
    GIM_Try, /*On fail goto*//*Label 148*/ 1521, // Rule ID 12 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule8Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner8,
      // Combiner Rule #8: extractvecelt_pairwise_add; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner8,
      GIR_Done,
    // Label 148: @1521
    GIM_Try, /*On fail goto*//*Label 149*/ 1531, // Rule ID 101 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule56Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner44,
      // Combiner Rule #56: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 149: @1531
    GIM_Reject,
    // Label 46: @1532
    GIM_Try, /*On fail goto*//*Label 150*/ 1542, // Rule ID 96 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule52Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner40,
      // Combiner Rule #52: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 150: @1542
    GIM_Try, /*On fail goto*//*Label 151*/ 1552, // Rule ID 97 //
      GIM_CheckSimplePredicate, GICXXPred_Simple_IsRule53Enabled,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GICXXPred_MI_Predicate_GICombiner41,
      // Combiner Rule #53: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
      GIR_CustomAction, GICXXCustomAction_CombineApplyGICombiner26,
      GIR_Done,
    // Label 151: @1552
    GIM_Reject,
    // Label 47: @1553
    GIM_Reject,
    };
  return MatchTable0;
}
#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

