/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * BPF Disassembler                                                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static std::enable_if_t<std::is_integral<InsnType>::value>
insertBits(InsnType &field, InsnType bits, unsigned startBit, unsigned numBits) {
  assert(startBit + numBits <= sizeof field * 8);
  field |= (InsnType)bits << startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value>
insertBits(InsnType &field, uint64_t bits, unsigned startBit, unsigned numBits) {
  field.insertBits(bits, startBit, numBits);
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTableBPF64[] = {
/* 0 */       MCD::OPC_ExtractField, 56, 8,  // Inst{63-56} ...
/* 3 */       MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 19
/* 8 */       MCD::OPC_CheckField, 32, 16, 0, 24, 7, 0, // Skip to: 1831
/* 15 */      MCD::OPC_Decode, 152, 2, 0, // Opcode: ADD_ri_32
/* 19 */      MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 28
/* 24 */      MCD::OPC_Decode, 181, 2, 1, // Opcode: JMP
/* 28 */      MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 37
/* 33 */      MCD::OPC_Decode, 182, 2, 2, // Opcode: JMPL
/* 37 */      MCD::OPC_FilterValue, 7, 11, 0, 0, // Skip to: 53
/* 42 */      MCD::OPC_CheckField, 32, 16, 0, 246, 6, 0, // Skip to: 1831
/* 49 */      MCD::OPC_Decode, 151, 2, 3, // Opcode: ADD_ri
/* 53 */      MCD::OPC_FilterValue, 12, 11, 0, 0, // Skip to: 69
/* 58 */      MCD::OPC_CheckField, 32, 16, 0, 230, 6, 0, // Skip to: 1831
/* 65 */      MCD::OPC_Decode, 154, 2, 4, // Opcode: ADD_rr_32
/* 69 */      MCD::OPC_FilterValue, 15, 11, 0, 0, // Skip to: 85
/* 74 */      MCD::OPC_CheckField, 32, 16, 0, 214, 6, 0, // Skip to: 1831
/* 81 */      MCD::OPC_Decode, 153, 2, 5, // Opcode: ADD_rr
/* 85 */      MCD::OPC_FilterValue, 20, 11, 0, 0, // Skip to: 101
/* 90 */      MCD::OPC_CheckField, 32, 16, 0, 198, 6, 0, // Skip to: 1831
/* 97 */      MCD::OPC_Decode, 170, 3, 0, // Opcode: SUB_ri_32
/* 101 */     MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 110
/* 106 */     MCD::OPC_Decode, 177, 2, 6, // Opcode: JEQ_ri
/* 110 */     MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 119
/* 115 */     MCD::OPC_Decode, 178, 2, 7, // Opcode: JEQ_ri_32
/* 119 */     MCD::OPC_FilterValue, 23, 11, 0, 0, // Skip to: 135
/* 124 */     MCD::OPC_CheckField, 32, 16, 0, 164, 6, 0, // Skip to: 1831
/* 131 */     MCD::OPC_Decode, 169, 3, 3, // Opcode: SUB_ri
/* 135 */     MCD::OPC_FilterValue, 24, 23, 0, 0, // Skip to: 163
/* 140 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 143 */     MCD::OPC_FilterValue, 0, 147, 6, 0, // Skip to: 1831
/* 148 */     MCD::OPC_CheckField, 52, 4, 0, 4, 0, 0, // Skip to: 159
/* 155 */     MCD::OPC_Decode, 235, 2, 8, // Opcode: LD_imm64
/* 159 */     MCD::OPC_Decode, 236, 2, 9, // Opcode: LD_pseudo
/* 163 */     MCD::OPC_FilterValue, 28, 11, 0, 0, // Skip to: 179
/* 168 */     MCD::OPC_CheckField, 32, 16, 0, 120, 6, 0, // Skip to: 1831
/* 175 */     MCD::OPC_Decode, 172, 3, 4, // Opcode: SUB_rr_32
/* 179 */     MCD::OPC_FilterValue, 29, 4, 0, 0, // Skip to: 188
/* 184 */     MCD::OPC_Decode, 179, 2, 10, // Opcode: JEQ_rr
/* 188 */     MCD::OPC_FilterValue, 30, 4, 0, 0, // Skip to: 197
/* 193 */     MCD::OPC_Decode, 180, 2, 11, // Opcode: JEQ_rr_32
/* 197 */     MCD::OPC_FilterValue, 31, 11, 0, 0, // Skip to: 213
/* 202 */     MCD::OPC_CheckField, 32, 16, 0, 86, 6, 0, // Skip to: 1831
/* 209 */     MCD::OPC_Decode, 171, 3, 5, // Opcode: SUB_rr
/* 213 */     MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 222
/* 218 */     MCD::OPC_Decode, 231, 2, 2, // Opcode: LD_ABS_W
/* 222 */     MCD::OPC_FilterValue, 36, 11, 0, 0, // Skip to: 238
/* 227 */     MCD::OPC_CheckField, 32, 16, 0, 61, 6, 0, // Skip to: 1831
/* 234 */     MCD::OPC_Decode, 255, 2, 0, // Opcode: MUL_ri_32
/* 238 */     MCD::OPC_FilterValue, 37, 4, 0, 0, // Skip to: 247
/* 243 */     MCD::OPC_Decode, 207, 2, 6, // Opcode: JUGT_ri
/* 247 */     MCD::OPC_FilterValue, 38, 4, 0, 0, // Skip to: 256
/* 252 */     MCD::OPC_Decode, 208, 2, 7, // Opcode: JUGT_ri_32
/* 256 */     MCD::OPC_FilterValue, 39, 11, 0, 0, // Skip to: 272
/* 261 */     MCD::OPC_CheckField, 32, 16, 0, 27, 6, 0, // Skip to: 1831
/* 268 */     MCD::OPC_Decode, 254, 2, 3, // Opcode: MUL_ri
/* 272 */     MCD::OPC_FilterValue, 40, 4, 0, 0, // Skip to: 281
/* 277 */     MCD::OPC_Decode, 230, 2, 2, // Opcode: LD_ABS_H
/* 281 */     MCD::OPC_FilterValue, 44, 11, 0, 0, // Skip to: 297
/* 286 */     MCD::OPC_CheckField, 32, 16, 0, 2, 6, 0, // Skip to: 1831
/* 293 */     MCD::OPC_Decode, 129, 3, 4, // Opcode: MUL_rr_32
/* 297 */     MCD::OPC_FilterValue, 45, 4, 0, 0, // Skip to: 306
/* 302 */     MCD::OPC_Decode, 209, 2, 10, // Opcode: JUGT_rr
/* 306 */     MCD::OPC_FilterValue, 46, 4, 0, 0, // Skip to: 315
/* 311 */     MCD::OPC_Decode, 210, 2, 11, // Opcode: JUGT_rr_32
/* 315 */     MCD::OPC_FilterValue, 47, 11, 0, 0, // Skip to: 331
/* 320 */     MCD::OPC_CheckField, 32, 16, 0, 224, 5, 0, // Skip to: 1831
/* 327 */     MCD::OPC_Decode, 128, 3, 5, // Opcode: MUL_rr
/* 331 */     MCD::OPC_FilterValue, 48, 4, 0, 0, // Skip to: 340
/* 336 */     MCD::OPC_Decode, 229, 2, 2, // Opcode: LD_ABS_B
/* 340 */     MCD::OPC_FilterValue, 52, 21, 0, 0, // Skip to: 366
/* 345 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 348 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 357
/* 353 */     MCD::OPC_Decode, 172, 2, 0, // Opcode: DIV_ri_32
/* 357 */     MCD::OPC_FilterValue, 1, 189, 5, 0, // Skip to: 1831
/* 362 */     MCD::OPC_Decode, 139, 3, 0, // Opcode: SDIV_ri_32
/* 366 */     MCD::OPC_FilterValue, 53, 4, 0, 0, // Skip to: 375
/* 371 */     MCD::OPC_Decode, 203, 2, 6, // Opcode: JUGE_ri
/* 375 */     MCD::OPC_FilterValue, 54, 4, 0, 0, // Skip to: 384
/* 380 */     MCD::OPC_Decode, 204, 2, 7, // Opcode: JUGE_ri_32
/* 384 */     MCD::OPC_FilterValue, 55, 21, 0, 0, // Skip to: 410
/* 389 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 392 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 401
/* 397 */     MCD::OPC_Decode, 171, 2, 3, // Opcode: DIV_ri
/* 401 */     MCD::OPC_FilterValue, 1, 145, 5, 0, // Skip to: 1831
/* 406 */     MCD::OPC_Decode, 138, 3, 3, // Opcode: SDIV_ri
/* 410 */     MCD::OPC_FilterValue, 60, 21, 0, 0, // Skip to: 436
/* 415 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 418 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 427
/* 423 */     MCD::OPC_Decode, 174, 2, 4, // Opcode: DIV_rr_32
/* 427 */     MCD::OPC_FilterValue, 1, 119, 5, 0, // Skip to: 1831
/* 432 */     MCD::OPC_Decode, 141, 3, 4, // Opcode: SDIV_rr_32
/* 436 */     MCD::OPC_FilterValue, 61, 4, 0, 0, // Skip to: 445
/* 441 */     MCD::OPC_Decode, 205, 2, 10, // Opcode: JUGE_rr
/* 445 */     MCD::OPC_FilterValue, 62, 4, 0, 0, // Skip to: 454
/* 450 */     MCD::OPC_Decode, 206, 2, 11, // Opcode: JUGE_rr_32
/* 454 */     MCD::OPC_FilterValue, 63, 21, 0, 0, // Skip to: 480
/* 459 */     MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 462 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 471
/* 467 */     MCD::OPC_Decode, 173, 2, 5, // Opcode: DIV_rr
/* 471 */     MCD::OPC_FilterValue, 1, 75, 5, 0, // Skip to: 1831
/* 476 */     MCD::OPC_Decode, 140, 3, 5, // Opcode: SDIV_rr
/* 480 */     MCD::OPC_FilterValue, 64, 4, 0, 0, // Skip to: 489
/* 485 */     MCD::OPC_Decode, 234, 2, 12, // Opcode: LD_IND_W
/* 489 */     MCD::OPC_FilterValue, 68, 11, 0, 0, // Skip to: 505
/* 494 */     MCD::OPC_CheckField, 32, 16, 0, 50, 5, 0, // Skip to: 1831
/* 501 */     MCD::OPC_Decode, 134, 3, 0, // Opcode: OR_ri_32
/* 505 */     MCD::OPC_FilterValue, 71, 11, 0, 0, // Skip to: 521
/* 510 */     MCD::OPC_CheckField, 32, 16, 0, 34, 5, 0, // Skip to: 1831
/* 517 */     MCD::OPC_Decode, 133, 3, 3, // Opcode: OR_ri
/* 521 */     MCD::OPC_FilterValue, 72, 4, 0, 0, // Skip to: 530
/* 526 */     MCD::OPC_Decode, 233, 2, 12, // Opcode: LD_IND_H
/* 530 */     MCD::OPC_FilterValue, 76, 11, 0, 0, // Skip to: 546
/* 535 */     MCD::OPC_CheckField, 32, 16, 0, 9, 5, 0, // Skip to: 1831
/* 542 */     MCD::OPC_Decode, 136, 3, 4, // Opcode: OR_rr_32
/* 546 */     MCD::OPC_FilterValue, 79, 11, 0, 0, // Skip to: 562
/* 551 */     MCD::OPC_CheckField, 32, 16, 0, 249, 4, 0, // Skip to: 1831
/* 558 */     MCD::OPC_Decode, 135, 3, 5, // Opcode: OR_rr
/* 562 */     MCD::OPC_FilterValue, 80, 4, 0, 0, // Skip to: 571
/* 567 */     MCD::OPC_Decode, 232, 2, 12, // Opcode: LD_IND_B
/* 571 */     MCD::OPC_FilterValue, 84, 11, 0, 0, // Skip to: 587
/* 576 */     MCD::OPC_CheckField, 32, 16, 0, 224, 4, 0, // Skip to: 1831
/* 583 */     MCD::OPC_Decode, 156, 2, 0, // Opcode: AND_ri_32
/* 587 */     MCD::OPC_FilterValue, 85, 4, 0, 0, // Skip to: 596
/* 592 */     MCD::OPC_Decode, 183, 2, 6, // Opcode: JNE_ri
/* 596 */     MCD::OPC_FilterValue, 86, 4, 0, 0, // Skip to: 605
/* 601 */     MCD::OPC_Decode, 184, 2, 7, // Opcode: JNE_ri_32
/* 605 */     MCD::OPC_FilterValue, 87, 11, 0, 0, // Skip to: 621
/* 610 */     MCD::OPC_CheckField, 32, 16, 0, 190, 4, 0, // Skip to: 1831
/* 617 */     MCD::OPC_Decode, 155, 2, 3, // Opcode: AND_ri
/* 621 */     MCD::OPC_FilterValue, 92, 11, 0, 0, // Skip to: 637
/* 626 */     MCD::OPC_CheckField, 32, 16, 0, 174, 4, 0, // Skip to: 1831
/* 633 */     MCD::OPC_Decode, 158, 2, 4, // Opcode: AND_rr_32
/* 637 */     MCD::OPC_FilterValue, 93, 4, 0, 0, // Skip to: 646
/* 642 */     MCD::OPC_Decode, 185, 2, 10, // Opcode: JNE_rr
/* 646 */     MCD::OPC_FilterValue, 94, 4, 0, 0, // Skip to: 655
/* 651 */     MCD::OPC_Decode, 186, 2, 11, // Opcode: JNE_rr_32
/* 655 */     MCD::OPC_FilterValue, 95, 11, 0, 0, // Skip to: 671
/* 660 */     MCD::OPC_CheckField, 32, 16, 0, 140, 4, 0, // Skip to: 1831
/* 667 */     MCD::OPC_Decode, 157, 2, 5, // Opcode: AND_rr
/* 671 */     MCD::OPC_FilterValue, 97, 4, 0, 0, // Skip to: 680
/* 676 */     MCD::OPC_Decode, 226, 2, 13, // Opcode: LDW
/* 680 */     MCD::OPC_FilterValue, 98, 4, 0, 0, // Skip to: 689
/* 685 */     MCD::OPC_Decode, 168, 3, 14, // Opcode: STW_imm
/* 689 */     MCD::OPC_FilterValue, 99, 4, 0, 0, // Skip to: 698
/* 694 */     MCD::OPC_Decode, 166, 3, 15, // Opcode: STW
/* 698 */     MCD::OPC_FilterValue, 100, 11, 0, 0, // Skip to: 714
/* 703 */     MCD::OPC_CheckField, 32, 16, 0, 97, 4, 0, // Skip to: 1831
/* 710 */     MCD::OPC_Decode, 143, 3, 0, // Opcode: SLL_ri_32
/* 714 */     MCD::OPC_FilterValue, 101, 4, 0, 0, // Skip to: 723
/* 719 */     MCD::OPC_Decode, 191, 2, 6, // Opcode: JSGT_ri
/* 723 */     MCD::OPC_FilterValue, 102, 4, 0, 0, // Skip to: 732
/* 728 */     MCD::OPC_Decode, 192, 2, 7, // Opcode: JSGT_ri_32
/* 732 */     MCD::OPC_FilterValue, 103, 11, 0, 0, // Skip to: 748
/* 737 */     MCD::OPC_CheckField, 32, 16, 0, 63, 4, 0, // Skip to: 1831
/* 744 */     MCD::OPC_Decode, 142, 3, 3, // Opcode: SLL_ri
/* 748 */     MCD::OPC_FilterValue, 105, 4, 0, 0, // Skip to: 757
/* 753 */     MCD::OPC_Decode, 223, 2, 13, // Opcode: LDH
/* 757 */     MCD::OPC_FilterValue, 106, 4, 0, 0, // Skip to: 766
/* 762 */     MCD::OPC_Decode, 165, 3, 14, // Opcode: STH_imm
/* 766 */     MCD::OPC_FilterValue, 107, 4, 0, 0, // Skip to: 775
/* 771 */     MCD::OPC_Decode, 163, 3, 15, // Opcode: STH
/* 775 */     MCD::OPC_FilterValue, 108, 11, 0, 0, // Skip to: 791
/* 780 */     MCD::OPC_CheckField, 32, 16, 0, 20, 4, 0, // Skip to: 1831
/* 787 */     MCD::OPC_Decode, 145, 3, 4, // Opcode: SLL_rr_32
/* 791 */     MCD::OPC_FilterValue, 109, 4, 0, 0, // Skip to: 800
/* 796 */     MCD::OPC_Decode, 193, 2, 10, // Opcode: JSGT_rr
/* 800 */     MCD::OPC_FilterValue, 110, 4, 0, 0, // Skip to: 809
/* 805 */     MCD::OPC_Decode, 194, 2, 11, // Opcode: JSGT_rr_32
/* 809 */     MCD::OPC_FilterValue, 111, 11, 0, 0, // Skip to: 825
/* 814 */     MCD::OPC_CheckField, 32, 16, 0, 242, 3, 0, // Skip to: 1831
/* 821 */     MCD::OPC_Decode, 144, 3, 5, // Opcode: SLL_rr
/* 825 */     MCD::OPC_FilterValue, 113, 4, 0, 0, // Skip to: 834
/* 830 */     MCD::OPC_Decode, 219, 2, 13, // Opcode: LDB
/* 834 */     MCD::OPC_FilterValue, 114, 4, 0, 0, // Skip to: 843
/* 839 */     MCD::OPC_Decode, 160, 3, 14, // Opcode: STB_imm
/* 843 */     MCD::OPC_FilterValue, 115, 4, 0, 0, // Skip to: 852
/* 848 */     MCD::OPC_Decode, 158, 3, 15, // Opcode: STB
/* 852 */     MCD::OPC_FilterValue, 116, 11, 0, 0, // Skip to: 868
/* 857 */     MCD::OPC_CheckField, 32, 16, 0, 199, 3, 0, // Skip to: 1831
/* 864 */     MCD::OPC_Decode, 155, 3, 0, // Opcode: SRL_ri_32
/* 868 */     MCD::OPC_FilterValue, 117, 4, 0, 0, // Skip to: 877
/* 873 */     MCD::OPC_Decode, 187, 2, 6, // Opcode: JSGE_ri
/* 877 */     MCD::OPC_FilterValue, 118, 4, 0, 0, // Skip to: 886
/* 882 */     MCD::OPC_Decode, 188, 2, 7, // Opcode: JSGE_ri_32
/* 886 */     MCD::OPC_FilterValue, 119, 11, 0, 0, // Skip to: 902
/* 891 */     MCD::OPC_CheckField, 32, 16, 0, 165, 3, 0, // Skip to: 1831
/* 898 */     MCD::OPC_Decode, 154, 3, 3, // Opcode: SRL_ri
/* 902 */     MCD::OPC_FilterValue, 121, 4, 0, 0, // Skip to: 911
/* 907 */     MCD::OPC_Decode, 222, 2, 13, // Opcode: LDD
/* 911 */     MCD::OPC_FilterValue, 122, 4, 0, 0, // Skip to: 920
/* 916 */     MCD::OPC_Decode, 162, 3, 14, // Opcode: STD_imm
/* 920 */     MCD::OPC_FilterValue, 123, 4, 0, 0, // Skip to: 929
/* 925 */     MCD::OPC_Decode, 161, 3, 15, // Opcode: STD
/* 929 */     MCD::OPC_FilterValue, 124, 11, 0, 0, // Skip to: 945
/* 934 */     MCD::OPC_CheckField, 32, 16, 0, 122, 3, 0, // Skip to: 1831
/* 941 */     MCD::OPC_Decode, 157, 3, 4, // Opcode: SRL_rr_32
/* 945 */     MCD::OPC_FilterValue, 125, 4, 0, 0, // Skip to: 954
/* 950 */     MCD::OPC_Decode, 189, 2, 10, // Opcode: JSGE_rr
/* 954 */     MCD::OPC_FilterValue, 126, 4, 0, 0, // Skip to: 963
/* 959 */     MCD::OPC_Decode, 190, 2, 11, // Opcode: JSGE_rr_32
/* 963 */     MCD::OPC_FilterValue, 127, 11, 0, 0, // Skip to: 979
/* 968 */     MCD::OPC_CheckField, 32, 16, 0, 88, 3, 0, // Skip to: 1831
/* 975 */     MCD::OPC_Decode, 156, 3, 5, // Opcode: SRL_rr
/* 979 */     MCD::OPC_FilterValue, 129, 1, 4, 0, 0, // Skip to: 989
/* 985 */     MCD::OPC_Decode, 228, 2, 13, // Opcode: LDWSX
/* 989 */     MCD::OPC_FilterValue, 132, 1, 4, 0, 0, // Skip to: 999
/* 995 */     MCD::OPC_Decode, 130, 3, 16, // Opcode: NEG_32
/* 999 */     MCD::OPC_FilterValue, 133, 1, 4, 0, 0, // Skip to: 1009
/* 1005 */    MCD::OPC_Decode, 175, 2, 2, // Opcode: JAL
/* 1009 */    MCD::OPC_FilterValue, 135, 1, 4, 0, 0, // Skip to: 1019
/* 1015 */    MCD::OPC_Decode, 131, 3, 17, // Opcode: NEG_64
/* 1019 */    MCD::OPC_FilterValue, 137, 1, 4, 0, 0, // Skip to: 1029
/* 1025 */    MCD::OPC_Decode, 225, 2, 13, // Opcode: LDHSX
/* 1029 */    MCD::OPC_FilterValue, 141, 1, 4, 0, 0, // Skip to: 1039
/* 1035 */    MCD::OPC_Decode, 176, 2, 18, // Opcode: JALX
/* 1039 */    MCD::OPC_FilterValue, 145, 1, 4, 0, 0, // Skip to: 1049
/* 1045 */    MCD::OPC_Decode, 221, 2, 13, // Opcode: LDBSX
/* 1049 */    MCD::OPC_FilterValue, 148, 1, 21, 0, 0, // Skip to: 1076
/* 1055 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1058 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1067
/* 1063 */    MCD::OPC_Decode, 241, 2, 0, // Opcode: MOD_ri_32
/* 1067 */    MCD::OPC_FilterValue, 1, 247, 2, 0, // Skip to: 1831
/* 1072 */    MCD::OPC_Decode, 147, 3, 0, // Opcode: SMOD_ri_32
/* 1076 */    MCD::OPC_FilterValue, 149, 1, 11, 0, 0, // Skip to: 1093
/* 1082 */    MCD::OPC_CheckField, 0, 32, 0, 230, 2, 0, // Skip to: 1831
/* 1089 */    MCD::OPC_Decode, 137, 3, 19, // Opcode: RET
/* 1093 */    MCD::OPC_FilterValue, 151, 1, 21, 0, 0, // Skip to: 1120
/* 1099 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1102 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1111
/* 1107 */    MCD::OPC_Decode, 240, 2, 3, // Opcode: MOD_ri
/* 1111 */    MCD::OPC_FilterValue, 1, 203, 2, 0, // Skip to: 1831
/* 1116 */    MCD::OPC_Decode, 146, 3, 3, // Opcode: SMOD_ri
/* 1120 */    MCD::OPC_FilterValue, 156, 1, 21, 0, 0, // Skip to: 1147
/* 1126 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1129 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1138
/* 1134 */    MCD::OPC_Decode, 243, 2, 4, // Opcode: MOD_rr_32
/* 1138 */    MCD::OPC_FilterValue, 1, 176, 2, 0, // Skip to: 1831
/* 1143 */    MCD::OPC_Decode, 149, 3, 4, // Opcode: SMOD_rr_32
/* 1147 */    MCD::OPC_FilterValue, 159, 1, 21, 0, 0, // Skip to: 1174
/* 1153 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1156 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1165
/* 1161 */    MCD::OPC_Decode, 242, 2, 5, // Opcode: MOD_rr
/* 1165 */    MCD::OPC_FilterValue, 1, 149, 2, 0, // Skip to: 1831
/* 1170 */    MCD::OPC_Decode, 148, 3, 5, // Opcode: SMOD_rr
/* 1174 */    MCD::OPC_FilterValue, 164, 1, 11, 0, 0, // Skip to: 1191
/* 1180 */    MCD::OPC_CheckField, 32, 16, 0, 132, 2, 0, // Skip to: 1831
/* 1187 */    MCD::OPC_Decode, 191, 3, 0, // Opcode: XOR_ri_32
/* 1191 */    MCD::OPC_FilterValue, 165, 1, 4, 0, 0, // Skip to: 1201
/* 1197 */    MCD::OPC_Decode, 215, 2, 6, // Opcode: JULT_ri
/* 1201 */    MCD::OPC_FilterValue, 166, 1, 4, 0, 0, // Skip to: 1211
/* 1207 */    MCD::OPC_Decode, 216, 2, 7, // Opcode: JULT_ri_32
/* 1211 */    MCD::OPC_FilterValue, 167, 1, 11, 0, 0, // Skip to: 1228
/* 1217 */    MCD::OPC_CheckField, 32, 16, 0, 95, 2, 0, // Skip to: 1831
/* 1224 */    MCD::OPC_Decode, 190, 3, 3, // Opcode: XOR_ri
/* 1228 */    MCD::OPC_FilterValue, 172, 1, 11, 0, 0, // Skip to: 1245
/* 1234 */    MCD::OPC_CheckField, 32, 16, 0, 78, 2, 0, // Skip to: 1831
/* 1241 */    MCD::OPC_Decode, 193, 3, 4, // Opcode: XOR_rr_32
/* 1245 */    MCD::OPC_FilterValue, 173, 1, 4, 0, 0, // Skip to: 1255
/* 1251 */    MCD::OPC_Decode, 217, 2, 10, // Opcode: JULT_rr
/* 1255 */    MCD::OPC_FilterValue, 174, 1, 4, 0, 0, // Skip to: 1265
/* 1261 */    MCD::OPC_Decode, 218, 2, 11, // Opcode: JULT_rr_32
/* 1265 */    MCD::OPC_FilterValue, 175, 1, 11, 0, 0, // Skip to: 1282
/* 1271 */    MCD::OPC_CheckField, 32, 16, 0, 41, 2, 0, // Skip to: 1831
/* 1278 */    MCD::OPC_Decode, 192, 3, 5, // Opcode: XOR_rr
/* 1282 */    MCD::OPC_FilterValue, 180, 1, 11, 0, 0, // Skip to: 1299
/* 1288 */    MCD::OPC_CheckField, 32, 16, 0, 24, 2, 0, // Skip to: 1831
/* 1295 */    MCD::OPC_Decode, 251, 2, 20, // Opcode: MOV_ri_32
/* 1299 */    MCD::OPC_FilterValue, 181, 1, 4, 0, 0, // Skip to: 1309
/* 1305 */    MCD::OPC_Decode, 211, 2, 6, // Opcode: JULE_ri
/* 1309 */    MCD::OPC_FilterValue, 182, 1, 4, 0, 0, // Skip to: 1319
/* 1315 */    MCD::OPC_Decode, 212, 2, 7, // Opcode: JULE_ri_32
/* 1319 */    MCD::OPC_FilterValue, 183, 1, 11, 0, 0, // Skip to: 1336
/* 1325 */    MCD::OPC_CheckField, 32, 16, 0, 243, 1, 0, // Skip to: 1831
/* 1332 */    MCD::OPC_Decode, 250, 2, 8, // Opcode: MOV_ri
/* 1336 */    MCD::OPC_FilterValue, 188, 1, 30, 0, 0, // Skip to: 1372
/* 1342 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1345 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1354
/* 1350 */    MCD::OPC_Decode, 253, 2, 21, // Opcode: MOV_rr_32
/* 1354 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 1363
/* 1359 */    MCD::OPC_Decode, 247, 2, 21, // Opcode: MOVSX_rr_32_8
/* 1363 */    MCD::OPC_FilterValue, 16, 207, 1, 0, // Skip to: 1831
/* 1368 */    MCD::OPC_Decode, 246, 2, 21, // Opcode: MOVSX_rr_32_16
/* 1372 */    MCD::OPC_FilterValue, 189, 1, 4, 0, 0, // Skip to: 1382
/* 1378 */    MCD::OPC_Decode, 213, 2, 10, // Opcode: JULE_rr
/* 1382 */    MCD::OPC_FilterValue, 190, 1, 4, 0, 0, // Skip to: 1392
/* 1388 */    MCD::OPC_Decode, 214, 2, 11, // Opcode: JULE_rr_32
/* 1392 */    MCD::OPC_FilterValue, 191, 1, 39, 0, 0, // Skip to: 1437
/* 1398 */    MCD::OPC_ExtractField, 32, 16,  // Inst{47-32} ...
/* 1401 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1410
/* 1406 */    MCD::OPC_Decode, 252, 2, 22, // Opcode: MOV_rr
/* 1410 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 1419
/* 1415 */    MCD::OPC_Decode, 248, 2, 22, // Opcode: MOVSX_rr_8
/* 1419 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1428
/* 1424 */    MCD::OPC_Decode, 244, 2, 22, // Opcode: MOVSX_rr_16
/* 1428 */    MCD::OPC_FilterValue, 32, 142, 1, 0, // Skip to: 1831
/* 1433 */    MCD::OPC_Decode, 245, 2, 22, // Opcode: MOVSX_rr_32
/* 1437 */    MCD::OPC_FilterValue, 195, 1, 11, 0, 0, // Skip to: 1454
/* 1443 */    MCD::OPC_CheckField, 4, 4, 0, 125, 1, 0, // Skip to: 1831
/* 1450 */    MCD::OPC_Decode, 174, 3, 23, // Opcode: XADDW
/* 1454 */    MCD::OPC_FilterValue, 196, 1, 11, 0, 0, // Skip to: 1471
/* 1460 */    MCD::OPC_CheckField, 32, 16, 0, 108, 1, 0, // Skip to: 1831
/* 1467 */    MCD::OPC_Decode, 151, 3, 0, // Opcode: SRA_ri_32
/* 1471 */    MCD::OPC_FilterValue, 197, 1, 4, 0, 0, // Skip to: 1481
/* 1477 */    MCD::OPC_Decode, 199, 2, 6, // Opcode: JSLT_ri
/* 1481 */    MCD::OPC_FilterValue, 198, 1, 4, 0, 0, // Skip to: 1491
/* 1487 */    MCD::OPC_Decode, 200, 2, 7, // Opcode: JSLT_ri_32
/* 1491 */    MCD::OPC_FilterValue, 199, 1, 11, 0, 0, // Skip to: 1508
/* 1497 */    MCD::OPC_CheckField, 32, 16, 0, 71, 1, 0, // Skip to: 1831
/* 1504 */    MCD::OPC_Decode, 150, 3, 3, // Opcode: SRA_ri
/* 1508 */    MCD::OPC_FilterValue, 204, 1, 11, 0, 0, // Skip to: 1525
/* 1514 */    MCD::OPC_CheckField, 32, 16, 0, 54, 1, 0, // Skip to: 1831
/* 1521 */    MCD::OPC_Decode, 153, 3, 4, // Opcode: SRA_rr_32
/* 1525 */    MCD::OPC_FilterValue, 205, 1, 4, 0, 0, // Skip to: 1535
/* 1531 */    MCD::OPC_Decode, 201, 2, 10, // Opcode: JSLT_rr
/* 1535 */    MCD::OPC_FilterValue, 206, 1, 4, 0, 0, // Skip to: 1545
/* 1541 */    MCD::OPC_Decode, 202, 2, 11, // Opcode: JSLT_rr_32
/* 1545 */    MCD::OPC_FilterValue, 207, 1, 11, 0, 0, // Skip to: 1562
/* 1551 */    MCD::OPC_CheckField, 32, 16, 0, 17, 1, 0, // Skip to: 1831
/* 1558 */    MCD::OPC_Decode, 152, 3, 5, // Opcode: SRA_rr
/* 1562 */    MCD::OPC_FilterValue, 212, 1, 30, 0, 0, // Skip to: 1598
/* 1568 */    MCD::OPC_ExtractField, 0, 32,  // Inst{31-0} ...
/* 1571 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1580
/* 1576 */    MCD::OPC_Decode, 237, 2, 17, // Opcode: LE16
/* 1580 */    MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 1589
/* 1585 */    MCD::OPC_Decode, 238, 2, 17, // Opcode: LE32
/* 1589 */    MCD::OPC_FilterValue, 64, 237, 0, 0, // Skip to: 1831
/* 1594 */    MCD::OPC_Decode, 239, 2, 17, // Opcode: LE64
/* 1598 */    MCD::OPC_FilterValue, 213, 1, 4, 0, 0, // Skip to: 1608
/* 1604 */    MCD::OPC_Decode, 195, 2, 6, // Opcode: JSLE_ri
/* 1608 */    MCD::OPC_FilterValue, 214, 1, 4, 0, 0, // Skip to: 1618
/* 1614 */    MCD::OPC_Decode, 196, 2, 7, // Opcode: JSLE_ri_32
/* 1618 */    MCD::OPC_FilterValue, 215, 1, 30, 0, 0, // Skip to: 1654
/* 1624 */    MCD::OPC_ExtractField, 0, 32,  // Inst{31-0} ...
/* 1627 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1636
/* 1632 */    MCD::OPC_Decode, 162, 2, 17, // Opcode: BSWAP16
/* 1636 */    MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 1645
/* 1641 */    MCD::OPC_Decode, 163, 2, 17, // Opcode: BSWAP32
/* 1645 */    MCD::OPC_FilterValue, 64, 181, 0, 0, // Skip to: 1831
/* 1650 */    MCD::OPC_Decode, 164, 2, 17, // Opcode: BSWAP64
/* 1654 */    MCD::OPC_FilterValue, 219, 1, 115, 0, 0, // Skip to: 1775
/* 1660 */    MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 1663 */    MCD::OPC_FilterValue, 0, 15, 0, 0, // Skip to: 1683
/* 1668 */    MCD::OPC_CheckField, 0, 4, 1, 4, 0, 0, // Skip to: 1679
/* 1675 */    MCD::OPC_Decode, 180, 3, 23, // Opcode: XFADDD
/* 1679 */    MCD::OPC_Decode, 173, 3, 23, // Opcode: XADDD
/* 1683 */    MCD::OPC_FilterValue, 4, 15, 0, 0, // Skip to: 1703
/* 1688 */    MCD::OPC_CheckField, 0, 4, 1, 4, 0, 0, // Skip to: 1699
/* 1695 */    MCD::OPC_Decode, 184, 3, 23, // Opcode: XFORD
/* 1699 */    MCD::OPC_Decode, 188, 3, 23, // Opcode: XORD
/* 1703 */    MCD::OPC_FilterValue, 5, 15, 0, 0, // Skip to: 1723
/* 1708 */    MCD::OPC_CheckField, 0, 4, 1, 4, 0, 0, // Skip to: 1719
/* 1715 */    MCD::OPC_Decode, 182, 3, 23, // Opcode: XFANDD
/* 1719 */    MCD::OPC_Decode, 176, 3, 23, // Opcode: XANDD
/* 1723 */    MCD::OPC_FilterValue, 10, 15, 0, 0, // Skip to: 1743
/* 1728 */    MCD::OPC_CheckField, 0, 4, 1, 4, 0, 0, // Skip to: 1739
/* 1735 */    MCD::OPC_Decode, 186, 3, 23, // Opcode: XFXORD
/* 1739 */    MCD::OPC_Decode, 194, 3, 23, // Opcode: XXORD
/* 1743 */    MCD::OPC_FilterValue, 14, 11, 0, 0, // Skip to: 1759
/* 1748 */    MCD::OPC_CheckField, 0, 4, 1, 76, 0, 0, // Skip to: 1831
/* 1755 */    MCD::OPC_Decode, 178, 3, 23, // Opcode: XCHGD
/* 1759 */    MCD::OPC_FilterValue, 15, 67, 0, 0, // Skip to: 1831
/* 1764 */    MCD::OPC_CheckField, 0, 4, 1, 60, 0, 0, // Skip to: 1831
/* 1771 */    MCD::OPC_Decode, 165, 2, 24, // Opcode: CMPXCHGD
/* 1775 */    MCD::OPC_FilterValue, 220, 1, 30, 0, 0, // Skip to: 1811
/* 1781 */    MCD::OPC_ExtractField, 0, 32,  // Inst{31-0} ...
/* 1784 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1793
/* 1789 */    MCD::OPC_Decode, 159, 2, 17, // Opcode: BE16
/* 1793 */    MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 1802
/* 1798 */    MCD::OPC_Decode, 160, 2, 17, // Opcode: BE32
/* 1802 */    MCD::OPC_FilterValue, 64, 24, 0, 0, // Skip to: 1831
/* 1807 */    MCD::OPC_Decode, 161, 2, 17, // Opcode: BE64
/* 1811 */    MCD::OPC_FilterValue, 221, 1, 4, 0, 0, // Skip to: 1821
/* 1817 */    MCD::OPC_Decode, 197, 2, 10, // Opcode: JSLE_rr
/* 1821 */    MCD::OPC_FilterValue, 222, 1, 4, 0, 0, // Skip to: 1831
/* 1827 */    MCD::OPC_Decode, 198, 2, 11, // Opcode: JSLE_rr_32
/* 1831 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableBPFALU3264[] = {
/* 0 */       MCD::OPC_ExtractField, 56, 8,  // Inst{63-56} ...
/* 3 */       MCD::OPC_FilterValue, 97, 4, 0, 0, // Skip to: 12
/* 8 */       MCD::OPC_Decode, 227, 2, 25, // Opcode: LDW32
/* 12 */      MCD::OPC_FilterValue, 99, 4, 0, 0, // Skip to: 21
/* 17 */      MCD::OPC_Decode, 167, 3, 26, // Opcode: STW32
/* 21 */      MCD::OPC_FilterValue, 105, 4, 0, 0, // Skip to: 30
/* 26 */      MCD::OPC_Decode, 224, 2, 25, // Opcode: LDH32
/* 30 */      MCD::OPC_FilterValue, 107, 4, 0, 0, // Skip to: 39
/* 35 */      MCD::OPC_Decode, 164, 3, 26, // Opcode: STH32
/* 39 */      MCD::OPC_FilterValue, 113, 4, 0, 0, // Skip to: 48
/* 44 */      MCD::OPC_Decode, 220, 2, 25, // Opcode: LDB32
/* 48 */      MCD::OPC_FilterValue, 115, 4, 0, 0, // Skip to: 57
/* 53 */      MCD::OPC_Decode, 159, 3, 26, // Opcode: STB32
/* 57 */      MCD::OPC_FilterValue, 195, 1, 115, 0, 0, // Skip to: 178
/* 63 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 66 */      MCD::OPC_FilterValue, 0, 15, 0, 0, // Skip to: 86
/* 71 */      MCD::OPC_CheckField, 0, 4, 1, 4, 0, 0, // Skip to: 82
/* 78 */      MCD::OPC_Decode, 181, 3, 27, // Opcode: XFADDW32
/* 82 */      MCD::OPC_Decode, 175, 3, 27, // Opcode: XADDW32
/* 86 */      MCD::OPC_FilterValue, 4, 15, 0, 0, // Skip to: 106
/* 91 */      MCD::OPC_CheckField, 0, 4, 1, 4, 0, 0, // Skip to: 102
/* 98 */      MCD::OPC_Decode, 185, 3, 27, // Opcode: XFORW32
/* 102 */     MCD::OPC_Decode, 189, 3, 27, // Opcode: XORW32
/* 106 */     MCD::OPC_FilterValue, 5, 15, 0, 0, // Skip to: 126
/* 111 */     MCD::OPC_CheckField, 0, 4, 1, 4, 0, 0, // Skip to: 122
/* 118 */     MCD::OPC_Decode, 183, 3, 27, // Opcode: XFANDW32
/* 122 */     MCD::OPC_Decode, 177, 3, 27, // Opcode: XANDW32
/* 126 */     MCD::OPC_FilterValue, 10, 15, 0, 0, // Skip to: 146
/* 131 */     MCD::OPC_CheckField, 0, 4, 1, 4, 0, 0, // Skip to: 142
/* 138 */     MCD::OPC_Decode, 187, 3, 27, // Opcode: XFXORW32
/* 142 */     MCD::OPC_Decode, 195, 3, 27, // Opcode: XXORW32
/* 146 */     MCD::OPC_FilterValue, 14, 11, 0, 0, // Skip to: 162
/* 151 */     MCD::OPC_CheckField, 0, 4, 1, 20, 0, 0, // Skip to: 178
/* 158 */     MCD::OPC_Decode, 179, 3, 27, // Opcode: XCHGW32
/* 162 */     MCD::OPC_FilterValue, 15, 11, 0, 0, // Skip to: 178
/* 167 */     MCD::OPC_CheckField, 0, 4, 1, 4, 0, 0, // Skip to: 178
/* 174 */     MCD::OPC_Decode, 166, 2, 28, // Opcode: CMPXCHGW32
/* 178 */     MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  llvm_unreachable("Invalid index!");
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    insertBits(tmp, fieldFromInstruction(insn, 52, 4), 16, 4);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 0, 32);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 48, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    insertBits(tmp, fieldFromInstruction(insn, 52, 4), 16, 4);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 32, 20);
    if (!Check(S, decodeMemoryOpValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 52, 4);
    if (!Check(S, DecodeGPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      uint64_t Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      uint64_t PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      uint64_t NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
